"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// import React from "react";
var React = require("react");

var PText = exports.PText = function (_React$Component) {
  _inherits(PText, _React$Component);

  function PText(props) {
    _classCallCheck(this, PText);

    var _this = _possibleConstructorReturn(this, (PText.__proto__ || Object.getPrototypeOf(PText)).call(this, props));

    _this.state = {
      trainingSet: _this.props.ts || [],
      probs: {},
      prediction: "",
      cursorIdx: 1,
      usrTxt: ""
    };
    _this.train = _this.train.bind(_this);
    _this.predict = _this.predict.bind(_this);
    _this.handleTextInput = _this.handleTextInput.bind(_this);
    return _this;
  }

  _createClass(PText, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.state.trainingSet.unshift(null);
      this.state.trainingSet.push(null);
      this.state.trainingSet.push(null);
      this.train();
    }
  }, {
    key: "handleTextInput",
    value: function handleTextInput(e) {
      console.log(e.target.value, " ||| ", this.state.usrTxt);

      var newPrediction = this.predict(e.target.value, " ");
      if (e.target.value <= this.state.usrTxt) {
        console.log("should break");
        newPrediction = "";
        // if 
      }
      //if e.target.value === this.state.usrTxt
      //must have deleted suggestion
      //if e.target.value < this.state.usrTxt
      //must have deleted a bunch

      var $textarea = document.getElementById(this.props.id);
      //if key is not "backspace"
      //increment cursorIdx
      //else
      //decrement cursorIdx
      // this.setState({cursorIdx: this.state.cursorIdx+1})
      this.setState({ usrTxt: e.target.value }, function () {
        if (newPrediction) {
          this.setState({ prediction: newPrediction }, function () {
            $textarea.value = this.state.usrTxt + this.state.prediction;
            $textarea.selectionStart = this.state.usrTxt.length;
            $textarea.selectionEnd = $textarea.value.length + this.state.prediction.length;
          });
        }
      });
    }
  }, {
    key: "train",
    value: function train() {
      var _this2 = this;

      var probabilities = {};
      this.state.trainingSet.forEach(function (glyph, idx) {
        if (typeof glyph === "string") {
          glyph = glyph.split('').map(function (el) {
            return el === '.' ? '#' : el;
          }).join('');
        }
        var penult = _this2.state.trainingSet[idx - 2] || '',
            ult = _this2.state.trainingSet[idx - 1] || '',
            key = [penult, ult, glyph].join('.'),
            target = _this2.state.trainingSet[idx + 1] || '';

        //if triglyph does not already exist in probs, make it exist. 
        probabilities[key] = probabilities[key] ? probabilities[key] : { total: 0 };
        probabilities[key].total++;
        //if triglyph does not have data for its current target, create that data
        probabilities[key][target] = probabilities[key][target] ? probabilities[key][target] : { total: 0 };
        probabilities[key][target].total++;
        for (var targ in probabilities[key]) {
          if (targ !== "total") {
            probabilities[key][targ].prob = probabilities[key][targ].total / probabilities[key].total;
          }
        }
      });
      this.setState({ probs: probabilities });
    }
  }, {
    key: "predict",
    value: function predict(prev, breakAtChar) {
      if (prev.length < 3) {
        return false;
      }
      var currentTriGlyph = prev.slice(-3).split('').join('.') || '..',
          breaksAt = breakAtChar || ' ',
          currentOutput = '',
          results = [];

      // this.setState({prediction: ""});

      while (currentOutput !== breaksAt) {
        // console.log("Current triglyph is: <<", currentTriGlyph, ">>")
        currentOutput = "";
        //generate random value.
        var roll = Math.random() * 100;
        //use value to determine output glyph
        for (var poss in this.state.probs[currentTriGlyph]) {
          if (poss !== "total") {
            roll -= this.state.probs[currentTriGlyph][poss].prob * 100;
          }
          // console.log(probabilities[currentTriGlyph][poss]);
          if (roll < 0) {
            currentOutput = poss;
            roll += 10000;
          }
        }
        if (typeof currentOutput === "string") {
          currentOutput = currentOutput.split('').map(function (el) {
            return el === '.' ? '#' : el;
          }).join('');
        }
        results.push(currentOutput);
        //update currentTriGlyph
        currentTriGlyph = currentTriGlyph.split(".");
        currentTriGlyph.shift();
        currentTriGlyph.push(currentOutput);
        currentTriGlyph = currentTriGlyph.join('.');
      }

      results = results.map(function (char) {
        return char === '#' ? '.' : char;
      }).join('');

      return results;
    }
  }, {
    key: "render",
    value: function render() {
      return React.createElement(
        "div",
        null,
        React.createElement("textarea", { id: this.props.id, onChange: this.handleTextInput })
      );
    }
  }]);

  return PText;
}(React.Component);

